/*----- PROTECTED REGION ID(AH501.h) ENABLED START -----*/
//=============================================================================
//
// file :        AH501.h
//
// description : Include for the AH501 class.
//
// project :     AH501.
//
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source:  $
// $Log:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef AH501_H
#define AH501_H


#include <tango.h>
#include "ClientSocket.h"
#include "SocketException.h"
#include "Listener.h"
#include <netdb.h>

extern pthread_mutex_t mutex1;
#define AFTER_ACQOFF_DELAY	100000



/*----- PROTECTED REGION END -----*/


/**
 *	AH501 class Description:
 *	This class implements basic "socket" IPC.
 */

namespace AH501_ns
{
	/*----- PROTECTED REGION ID(AH501::Additional Class Declarations) ENABLED START -----*/

		//		Additional Class Declarations

	/*----- PROTECTED REGION END -----*/	//	AH501::Additional Class Declarations


class AH501 : public Tango::Device_4Impl
{


	/*----- PROTECTED REGION ID(AH501::Data Members) ENABLED START -----*/

	//		Add your own data members
public:
  bool connected;


	/*----- PROTECTED REGION END -----*/	//	AH501::Data Members


//	Device property data members
public:		//	Hostname:	This is the hostname of the host to connect to.
	string	hostname;
	//	Port:	This is the port number to connect to.
	Tango::DevLong	port;
	//	Readtimeout:	Read timeout in milliseconds.
	Tango::DevShort	readtimeout;
	//	AutoAcquisition:	If true, the AH501 start auto-acquisition at startup.
	//	NOTE : The default values is true.
	Tango::DevBoolean	autoAcquisition;
	//	BinaryAcquisition:	Sets at startup the BIN or the ASCII acquisition
	Tango::DevBoolean	binaryAcquisition;
	//	Resolution:	Set at startup the desired bit resolution (16 o 24)
	Tango::DevShort	resolution;
	//	MajorVersion:	Major firmware version number
	Tango::DevShort	majorVersion;
	
//	Attribute data members
public:
	Tango::DevBoolean	*attr_AcqFlag_read;
	Tango::DevShort	*attr_Resolution_read;
	Tango::DevShort	*attr_Channels_read;
	Tango::DevShort	*attr_Range_read;
	Tango::DevBoolean	*attr_Binary_read;
	Tango::DevLong	*attr_Baudrate_read;
	Tango::DevBoolean	*attr_Offset_read;
	Tango::DevString	*attr_Version_read;
	Tango::DevLong	*attr_Channel_1_read;
	Tango::DevLong	*attr_Channel_2_read;
	Tango::DevLong	*attr_Channel_3_read;
	Tango::DevLong	*attr_Channel_4_read;



//	Constructors and destructors
public:
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	AH501(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	AH501(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	AH501(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The object destructor.
	 */	
	~AH501() {delete_device();};



//	Miscellaneous methods
public:
	/**
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/**
	 *	Initialize the device
	 */
	virtual void init_device();
	/**
	 *	Read the device properties from database
	 */
	 void get_device_property();
	/**
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	/**
	 *	Method      : AH501::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	virtual void read_attr_hardware(vector<long> &attr_list);


	/**
	 *	AcqFlag attribute related methods.
	 *	Description: Continuous data acquisition\n     1     Start continuous data acquisition (default at startup)\n     0    Stop continuous data acquisition\n
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar 
	 */
	virtual void read_AcqFlag(Tango::Attribute &attr);
	virtual void write_AcqFlag(Tango::WAttribute &attr);
	virtual bool is_AcqFlag_allowed(Tango::AttReqType type);



	/**
	 *	Resolution attribute related methods.
	 *	Description: Resolution of AD converters\n     16     Set resolution to 16 bits (default)\n     24     Set resolution to 24 bits\n
	 *
	 *	Data type:	Tango::DevShort
	 *	Attr type:	Scalar 
	 */
	virtual void read_Resolution(Tango::Attribute &attr);
	virtual void write_Resolution(Tango::WAttribute &attr);
	virtual bool is_Resolution_allowed(Tango::AttReqType type);



	/**
	 *	Channels attribute related methods.
	 *	Description: Number of channels to read\n     1      Read only one channel\n     2      Read two channels\n     4      Read all four channels (default)\n
	 *
	 *	Data type:	Tango::DevShort
	 *	Attr type:	Scalar 
	 */
	virtual void read_Channels(Tango::Attribute &attr);
	virtual void write_Channels(Tango::WAttribute &attr);
	virtual bool is_Channels_allowed(Tango::AttReqType type);



	/**
	 *	Range attribute related methods.
	 *	Description: Current Range setting\n     0      Maximum current range (default)\n     1      Intermediate Range\n     2      Minimum range\n
	 *
	 *	Data type:	Tango::DevShort
	 *	Attr type:	Scalar 
	 */
	virtual void read_Range(Tango::Attribute &attr);
	virtual void write_Range(Tango::WAttribute &attr);
	virtual bool is_Range_allowed(Tango::AttReqType type);



	/**
	 *	Binary attribute related methods.
	 *	Description: BIN         Data Format transmission settings\n     1     Transmission of data in binary format (default)\n     0    Transmission of data in extended-ASCII format\n
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar 
	 */
	virtual void read_Binary(Tango::Attribute &attr);
	virtual void write_Binary(Tango::WAttribute &attr);
	virtual bool is_Binary_allowed(Tango::AttReqType type);



	/**
	 *	Baudrate attribute related methods.
	 *	Description: Baudrate for communication\n     9600   throughput of 9600 bit/s\n     19200  throughput of 19200 bit/s\n     38400  throughput of 38400 bit/s\n     57600  throughput of 57600 bit/s\n     115200 throughput of 115200 bit/s (default)\n     230400 throughput of 230400 bit/s\n     460800 throughput of 460800 bit/s\n     921600 throughput of 921600 bit/s\n
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar 
	 */
	virtual void read_Baudrate(Tango::Attribute &attr);
	virtual void write_Baudrate(Tango::WAttribute &attr);
	virtual bool is_Baudrate_allowed(Tango::AttReqType type);



	/**
	 *	Offset attribute related methods.
	 *	Description: Offset Correction for ASCII Data (available only in BIN OFF mode)\n     1     Correction of data format (data are transmitted as decimal numbers, always referred to 24 bit)\n     0    Transmission of data in extended-ASCII hex format with no-correction (default)\n
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar 
	 */
	virtual void read_Offset(Tango::Attribute &attr);
	virtual void write_Offset(Tango::WAttribute &attr);
	virtual bool is_Offset_allowed(Tango::AttReqType type);



	/**
	 *	Version attribute related methods.
	 *	Description: Offset Correction for ASCII Data (available only in BIN OFF mode)\n     1     Correction of data format (data are transmitted as decimal numbers, always referred to 24 bit)\n     0    Transmission of data in extended-ASCII hex format with no-correction (default)\n
	 *
	 *	Data type:	Tango::DevString
	 *	Attr type:	Scalar 
	 */
	virtual void read_Version(Tango::Attribute &attr);
	virtual bool is_Version_allowed(Tango::AttReqType type);



	/**
	 *	Channel_1 attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar 
	 */
	virtual void read_Channel_1(Tango::Attribute &attr);
	virtual bool is_Channel_1_allowed(Tango::AttReqType type);



	/**
	 *	Channel_2 attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar 
	 */
	virtual void read_Channel_2(Tango::Attribute &attr);
	virtual bool is_Channel_2_allowed(Tango::AttReqType type);



	/**
	 *	Channel_3 attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar 
	 */
	virtual void read_Channel_3(Tango::Attribute &attr);
	virtual bool is_Channel_3_allowed(Tango::AttReqType type);



	/**
	 *	Channel_4 attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar 
	 */
	virtual void read_Channel_4(Tango::Attribute &attr);
	virtual bool is_Channel_4_allowed(Tango::AttReqType type);




	/**
	 *	Method      : AH501::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	void add_dynamic_attributes();

//	Command related methods
public: 


	/**
	 *	Command Acq_data_avg related methods.
	 */
	virtual Tango::DevVarLongArray *acq_data_avg(Tango::DevShort argin);
	virtual bool is_Acq_data_avg_allowed(const CORBA::Any &any);

	/**
	 *	Command Acq_data_raw related methods.
	 */
	virtual Tango::DevVarLongArray *acq_data_raw();
	virtual bool is_Acq_data_raw_allowed(const CORBA::Any &any);

	/**
	 *	Command Acq_data_syncr related methods.
	 */
	virtual Tango::DevVarLongArray *acq_data_syncr(Tango::DevShort argin);
	virtual bool is_Acq_data_syncr_allowed(const CORBA::Any &any);

	/**
	 *	Command ReadWrite related methods.
	 */
	virtual Tango::DevString read_write(Tango::DevString argin);
	virtual bool is_ReadWrite_allowed(const CORBA::Any &any);



	/*----- PROTECTED REGION ID(AH501::Additional Method prototypes) ENABLED START -----*/

	//	Additional Method prototypes
protected :	
	Listener *listener;
	std::string version;
	bool cmd_with_reply_or_not;
	
	bool stop_acquisition(void);

	/*----- PROTECTED REGION END -----*/	//	AH501::Additional Method prototypes

};

	/*----- PROTECTED REGION ID(AH501::Additional Classes Definitions) ENABLED START -----*/

	//	Additional Classes definitions

	/*----- PROTECTED REGION END -----*/	//	AH501::Additional Classes Definitions

} //	namespace

#endif	//	AH501_H
