/*----- PROTECTED REGION ID(AH501Class.h) ENABLED START -----*/
//=============================================================================
//
// file :        AH501Class.h
//
// description : Include for the AH501Class root class.
//               This class is the singleton class for.
//               the AH501 device class..
//               It contains all properties and methods which the .
//               AH501 requires only once e.g. the commands.
//
// project :     AH501.
//
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source:  $
// $Log:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef AH501CLASS_H
#define AH501CLASS_H

#include <tango.h>
#include <AH501.h>

/*----- PROTECTED REGION END -----*/

namespace AH501_ns
{
	/*----- PROTECTED REGION ID(AH501::classes for dynamic creation) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	AH501::classes for dynamic creation



//=========================================
//	Define classes for attributes
//=========================================
//	Attribute AcqFlag class definition
class AcqFlagAttrib: public Tango::Attr
{
public:
	AcqFlagAttrib():Attr("AcqFlag",
	                   Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~AcqFlagAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AH501 *>(dev))->read_AcqFlag(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AH501 *>(dev))->write_AcqFlag(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AH501 *>(dev))->is_AcqFlag_allowed(ty);}
};

//	Attribute Resolution class definition
class ResolutionAttrib: public Tango::Attr
{
public:
	ResolutionAttrib():Attr("Resolution",
	                   Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~ResolutionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AH501 *>(dev))->read_Resolution(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AH501 *>(dev))->write_Resolution(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AH501 *>(dev))->is_Resolution_allowed(ty);}
};

//	Attribute Channels class definition
class ChannelsAttrib: public Tango::Attr
{
public:
	ChannelsAttrib():Attr("Channels",
	                   Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~ChannelsAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AH501 *>(dev))->read_Channels(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AH501 *>(dev))->write_Channels(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AH501 *>(dev))->is_Channels_allowed(ty);}
};

//	Attribute Range class definition
class RangeAttrib: public Tango::Attr
{
public:
	RangeAttrib():Attr("Range",
	                   Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~RangeAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AH501 *>(dev))->read_Range(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AH501 *>(dev))->write_Range(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AH501 *>(dev))->is_Range_allowed(ty);}
};

//	Attribute Binary class definition
class BinaryAttrib: public Tango::Attr
{
public:
	BinaryAttrib():Attr("Binary",
	                   Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~BinaryAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AH501 *>(dev))->read_Binary(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AH501 *>(dev))->write_Binary(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AH501 *>(dev))->is_Binary_allowed(ty);}
};

//	Attribute Baudrate class definition
class BaudrateAttrib: public Tango::Attr
{
public:
	BaudrateAttrib():Attr("Baudrate",
	                   Tango::DEV_LONG, Tango::READ_WRITE) {};
	~BaudrateAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AH501 *>(dev))->read_Baudrate(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AH501 *>(dev))->write_Baudrate(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AH501 *>(dev))->is_Baudrate_allowed(ty);}
};

//	Attribute Offset class definition
class OffsetAttrib: public Tango::Attr
{
public:
	OffsetAttrib():Attr("Offset",
	                   Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~OffsetAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AH501 *>(dev))->read_Offset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AH501 *>(dev))->write_Offset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AH501 *>(dev))->is_Offset_allowed(ty);}
};

//	Attribute Version class definition
class VersionAttrib: public Tango::Attr
{
public:
	VersionAttrib():Attr("Version",
	                   Tango::DEV_STRING, Tango::READ) {};
	~VersionAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AH501 *>(dev))->read_Version(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AH501 *>(dev))->is_Version_allowed(ty);}
};

//	Attribute Channel_1 class definition
class Channel_1Attrib: public Tango::Attr
{
public:
	Channel_1Attrib():Attr("Channel_1",
	                   Tango::DEV_LONG, Tango::READ) {};
	~Channel_1Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AH501 *>(dev))->read_Channel_1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AH501 *>(dev))->is_Channel_1_allowed(ty);}
};

//	Attribute Channel_2 class definition
class Channel_2Attrib: public Tango::Attr
{
public:
	Channel_2Attrib():Attr("Channel_2",
	                   Tango::DEV_LONG, Tango::READ) {};
	~Channel_2Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AH501 *>(dev))->read_Channel_2(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AH501 *>(dev))->is_Channel_2_allowed(ty);}
};

//	Attribute Channel_3 class definition
class Channel_3Attrib: public Tango::Attr
{
public:
	Channel_3Attrib():Attr("Channel_3",
	                   Tango::DEV_LONG, Tango::READ) {};
	~Channel_3Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AH501 *>(dev))->read_Channel_3(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AH501 *>(dev))->is_Channel_3_allowed(ty);}
};

//	Attribute Channel_4 class definition
class Channel_4Attrib: public Tango::Attr
{
public:
	Channel_4Attrib():Attr("Channel_4",
	                   Tango::DEV_LONG, Tango::READ) {};
	~Channel_4Attrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AH501 *>(dev))->read_Channel_4(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AH501 *>(dev))->is_Channel_4_allowed(ty);}
};






//=========================================
//	Define classes for commands
//=========================================
//	Command Acq_data_avg class definition
class Acq_data_avgClass : public Tango::Command
{
public:
	Acq_data_avgClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	Acq_data_avgClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~Acq_data_avgClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH501 *>(dev))->is_Acq_data_avg_allowed(any);}
};

//	Command Acq_data_raw class definition
class Acq_data_rawClass : public Tango::Command
{
public:
	Acq_data_rawClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	Acq_data_rawClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~Acq_data_rawClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH501 *>(dev))->is_Acq_data_raw_allowed(any);}
};

//	Command Acq_data_syncr class definition
class Acq_data_syncrClass : public Tango::Command
{
public:
	Acq_data_syncrClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	Acq_data_syncrClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~Acq_data_syncrClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH501 *>(dev))->is_Acq_data_syncr_allowed(any);}
};

//	Command ReadWrite class definition
class ReadWriteClass : public Tango::Command
{
public:
	ReadWriteClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ReadWriteClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ReadWriteClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AH501 *>(dev))->is_ReadWrite_allowed(any);}
};





/**
 *	The TemplateDevServClass singleton definition
 */

class
#ifdef _TG_WINDOWS_
	__declspec(dllexport)
#endif
	AH501Class : public Tango::DeviceClass
{
	/*----- PROTECTED REGION ID(AH501::Additionnal DServer data members) ENABLED START -----*/
public:
	

	/*----- PROTECTED REGION END -----*/	//	AH501::Additionnal DServer data members



public:
//	write class properties data members
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static AH501Class *init(const char *);
	static AH501Class *instance();
	~AH501Class();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	AH501Class(string &);
	static AH501Class *_instance;
	void command_factory();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();
	void get_class_property();
	string get_cvstag();
	string get_cvsroot();

private:
	void device_factory(const Tango::DevVarStringArray *);
	void create_static_attribute_list(vector<Tango::Attr *> &);
	void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
	vector<string>	defaultAttList;
	Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);


};

}	//	namespace

#endif	//	AH501CLASS_H

